# Batteries included: builtin nose plugins

nose includes a number of builtin plugins that can make testing faster and easier.

Note

nose 0.11.2 includes a change to default plugin loading. Now, a 3rd party plugin with the same name as a builtin will be loaded instead of the builtin plugin.

- AllModules: collect tests in all modules
  - Options
  - Plugin
  - Source
- Attrib: tag and select tests with attributes
  - Simple syntax
  - Expression Evaluation
  - Options
  - Plugin
  - Source
- Capture: capture stdout during tests
  - Options
  - Plugin
  - Source
- Collect: Collect tests quickly
  - Options
  - Plugin
  - Source
- Cover: code coverage
  - Options
  - Plugin
  - Source
- Debug: drop into pdb on errors or failures
  - Options
  - Plugin
  - Source
- Deprecated: mark tests as deprecated
  - Options
  - Plugin
  - Source
- Doctests: run doctests with nose
  - Options
  - Plugin
  - Source
- Failure Detail: introspect asserts
  - Options
  - Plugin
  - Source
- Isolate: protect tests from (some) side-effects
  - Options
  - Plugin
  - Source
- Logcapture: capture logging during tests
  - Options
  - Plugin
  - Source
- Multiprocess: parallel testing
  - Overview
  - How tests are distributed
  - How results are collected and reported
  - Beware!
  - New Features in 1.1.0
  - Options
  - Plugin
  - Source
- Prof: enable profiling using the hotshot profiler
  - Options
  - Plugin
  - Source
- Skip: mark tests as skipped
  - Options
  - Plugin
  - Source
- Testid: add a test id to each test name output
  - Looping over failed tests
  - Options
  - Plugin
  - Source
- Xunit: output test results in xunit format
  - Options
  - Plugin
  - Source